<?php
namespace Geral\Entities;

use Geral\Util\Ambiente;
use Geral\Util\NovoCodigo;
use Geral\Util\DateUtil;

class Lista extends Base\Lista
{

    public static function novoCodigo(){

        $codigo = Novocodigo::geraCodigo(Ambiente::getNrorg(), 'LISTA', '1');
        return $codigo;

    }

    public static function insere($nrlista, $cdContador, $nrorg){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try{
            $lista = new Lista();
            $lista->setNrlista($nrlista);
            $lista->setCdlista($cdContador);
            $lista->setNrorg($nrorg);
            $lista->setNrorginclusao($nrorg);
            $lista->setNrorgultatu($nrorg);
            $lista->setDtinclusao(DateUtil::getDataAtual());
            $lista->setDtultatu(DateUtil::getDataAtual());
            $lista->setCdoperinclusao(Ambiente::getCdOperador());
            $lista->setCdoperultatu(Ambiente::getCdOperador());
            $lista->setIdativo('S');
            $lista->persist();

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }


    public static function deleta($nrorg, $nrlista){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            /** @var $lista Lista */
            $lista = self::getObjectByWhere(
                'NRORG = ? AND NRLISTA = ?', array($nrorg, $nrlista)
            );
            if ($lista instanceof Lista) {
                $lista->delete();

                $connection->flush();
                $connection->commit();
            }
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    /**
     * Deleta vários registros da lista
     * @param $nrorg
     * @param $nrlista
     * @throws \Exception
     */
    public static function deletaListas($nrorg, $nrlista){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            /** @var $lista Lista */
            $lista = self::getObjectsByWhere(
                'NRORG = ? AND NRLISTA = ?', array($nrorg, $nrlista)
            );
            foreach($lista as $registro){
                /** @var $registro Lista */
                $registro->delete();
            }

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function insereLista($nrlista, $cdContador, $nrorg){


        $lista = new Lista();
        $lista->setNrlista($nrlista);
        $lista->setCdlista($cdContador);
        $lista->setNrorg($nrorg);
        $lista->setNrorginclusao($nrorg);
        $lista->setNrorgultatu($nrorg);
        $lista->setDtinclusao(DateUtil::getDataAtual());
        $lista->setDtultatu(DateUtil::getDataAtual());
        $lista->setCdoperinclusao(Ambiente::getCdOperador());
        $lista->setCdoperultatu(Ambiente::getCdOperador());
        $lista->setIdativo('S');
        $lista->persist();

    }
}