<?php
namespace Teknisa\Model\Services\Repositories;


class FctItemcontrato extends \Doctrine\ORM\EntityRepository {

    public function findContractItemInfo($nrApropAgendamento) {
        $query = <<<SQL
            SELECT CO.NRCONTRATOFCT || ' - ' || CO.DSREFERENCIACONT AS CONTRACT_DESC,
                   IC.NMITEMCONTRATO, (SELECT HORADEC_HORACHAR(IC.QTMEDIDACONTR) FROM DUAL) AS QTMEDIDACONTR,
                   round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 2) || '%' AS PERCENT_COMPLETED,
                   round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 2) || '%' AS PERCENT_COMPLETED_ORIGIN,
                   AG.NRAPROPAGENDAMENTO, TO_CHAR(AG.DTAPROPRIACAO, 'DD/MM/YYYY') AS DTAPROPRIACAO,
                   (SELECT HORADEC_HORACHAR(AG.QTHORASAPROPRIADAS) FROM DUAL) AS QTHORASAPROPRIADAS,
                   (SELECT HORADEC_HORACHAR(AG.QTHORASAPROPRIADAS) FROM DUAL) AS QTHORASAPROPRIADAS_VIEW,
                   (SELECT HORADEC_HORACHAR(AA.TOTAL_APPROPRIATION) FROM DUAL) AS TOTAL_APPROPRIATION,
                   RA.NRRECURSOSAGENDCONT, RA.NRPARCNEPESSOA
              FROM FCT_APROPAGENDAMENTO  AG
              JOIN FCT_RECURSOSAGENDCONT RA ON RA.NRRECURSOSAGENDCONT = AG.NRRECURSOSAGENDCONT
              JOIN FCT_ITEMCONTRATO      IC ON IC.NRITEMOCONTRATO = RA.NRITEMOCONTRATO
              JOIN FCT_CONTRATO          CO ON CO.NRSEQCONTRATO = IC.NRSEQCONTRATO
              JOIN (SELECT SUM(AA.QTHORASAPROPRIADAS) AS TOTAL_APPROPRIATION, AA.NRRECURSOSAGENDCONT
                      FROM FCT_APROPAGENDAMENTO AA
                  GROUP BY AA.NRRECURSOSAGENDCONT) AA ON (AA.NRRECURSOSAGENDCONT = AG.NRRECURSOSAGENDCONT)
             WHERE AG.NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
SQL;

        $params = array(
            'NRAPROPAGENDAMENTO' => $nrApropAgendamento
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }



    public function findContractItemInfoExtraAppropriation($filters) {
        $query = <<<SQL
            SELECT *
            FROM (SELECT CO.NRCONTRATOFCT || ' - ' || CO.DSREFERENCIACONT AS CONTRACT_DESC,
                        IC.NMITEMCONTRATO, (SELECT HORADEC_HORACHAR(IC.QTMEDIDACONTR) FROM DUAL) AS QTMEDIDACONTR,
                        round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 2) || '%' AS PERCENT_COMPLETED,
                        round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 2) || '%' AS PERCENT_COMPLETED_ORIGIN,
                        AG.NRAPROPAGENDAMENTO, TO_CHAR(AG.DTAPROPRIACAO, 'DD/MM/YYYY') AS DTAPROPRIACAO,
                        (SELECT HORADEC_HORACHAR(AG.QTHORASAPROPRIADAS) FROM DUAL) AS QTHORASAPROPRIADAS,
                        (SELECT HORADEC_HORACHAR(AA.TOTAL_APPROPRIATION) FROM DUAL) AS TOTAL_APPROPRIATION,
                        RA.NRRECURSOSAGENDCONT, RA.NRPARCNEPESSOA
                    FROM FCT_APROPAGENDAMENTO  AG
                    JOIN FCT_RECURSOSAGENDCONT RA ON RA.NRRECURSOSAGENDCONT = AG.NRRECURSOSAGENDCONT
                    JOIN FCT_ITEMCONTRATO      IC ON IC.NRITEMOCONTRATO = RA.NRITEMOCONTRATO
                    JOIN FCT_CONTRATO          CO ON CO.NRSEQCONTRATO = IC.NRSEQCONTRATO
                    JOIN (SELECT SUM(AA.QTHORASAPROPRIADAS) AS TOTAL_APPROPRIATION, AA.NRRECURSOSAGENDCONT
                            FROM FCT_APROPAGENDAMENTO AA
                        GROUP BY AA.NRRECURSOSAGENDCONT) AA ON (AA.NRRECURSOSAGENDCONT = AG.NRRECURSOSAGENDCONT)
                   )
                   WHERE 1 = 1
                   $filters
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }

    public function findUserContractItemExtraAppropriation($user, $filters, $dtapropriacaoFilter, $serviceFilter) {
        $query = <<<SQL
        SELECT DISTINCT * FROM (
            SELECT CO.NRSEQCONTRATO AS ID, 'C'||CO.NRSEQCONTRATO AS ID_TREE, CO.NRCONTRATOFCT || ' - ' || CO.DSREFERENCIACONT AS NAME,
                NULL AS PROJECT_TREE, NULL AS PERCENT_COMPLETED, NULL AS PERCENT_COMPLETED_ORIGIN,
                'N' AS PROJECT, 'Y' AS CONTRACT, 'Y' AS CDA, NULL AS NRRECURSOSAGENDCONT,
                CO.NRSEQCONTRATO, 'N' AS APPROPRIATION, 0 AS DAD_ID, '' AS DAD_NAME,
                '' AS GRANDFATHER_NAME, '' AS QTMEDIDACONTR, NULL AS QTHORASAPROPRIADAS, NULL AS TOTAL_APPROPRIATION,
                NULL AS QTHORASAPROPRIADAS_VIEW
           FROM RESOURCE_T            RE
           JOIN OPERADOR              OP ON OP.CDOPERADOR = RE.EXTERNAL_CODE
           JOIN PARCNEGOCIO           PN ON PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
           JOIN FCT_RECURSOSAGENDCONT RA ON RA.NRPARCNEPESSOA = OP.NRPARCNEGOCIO
           JOIN FCT_APROPAGENDAMENTO  AG ON AG.NRRECURSOSAGENDCONT = RA.NRRECURSOSAGENDCONT

           JOIN FCT_ITEMCONTRATO      IC ON IC.NRITEMOCONTRATO = RA.NRITEMOCONTRATO
           JOIN FCT_CONTRATO          CO ON CO.NRSEQCONTRATO = IC.NRSEQCONTRATO
          WHERE RE.ID = :USER_ID
			AND RA.IDSITUARECGEND = '1'
            $dtapropriacaoFilter
            $serviceFilter
       GROUP BY CO.NRSEQCONTRATO, CO.NRCONTRATOFCT, CO.DSREFERENCIACONT, IC.NMITEMCONTRATO

          UNION

          SELECT IC.NRITEMOCONTRATO AS ID, 'S'||IC.NRITEMOCONTRATO AS ID_TREE, IC.NMITEMCONTRATO AS NAME,
                'C'||IC.NRSEQCONTRATO AS PROJECT_TREE,
                NULL AS PERCENT_COMPLETED,
                NULL AS PERCENT_COMPLETED_ORIGIN,
                'N' AS PROJECT, 'N' AS CONTRACT, 'Y' AS CDA, RA.NRRECURSOSAGENDCONT,
                CO.NRSEQCONTRATO, 'N' AS APPROPRIATION,
                CO.NRSEQCONTRATO AS DAD_ID, CO.NRCONTRATOFCT || ' - ' || CO.DSREFERENCIACONT AS DAD_NAME,
                '' AS GRANDFATHER_NAME, '' AS QTMEDIDACONTR, NULL AS QTHORASAPROPRIADAS, NULL AS TOTAL_APPROPRIATION,
                NULL AS QTHORASAPROPRIADAS_VIEW
           FROM RESOURCE_T            RE
           JOIN OPERADOR              OP ON OP.CDOPERADOR = RE.EXTERNAL_CODE
           JOIN PARCNEGOCIO           PN ON PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
           JOIN FCT_RECURSOSAGENDCONT RA ON RA.NRPARCNEPESSOA = OP.NRPARCNEGOCIO
           JOIN FCT_APROPAGENDAMENTO  AG ON AG.NRRECURSOSAGENDCONT = RA.NRRECURSOSAGENDCONT

           JOIN FCT_ITEMCONTRATO      IC ON IC.NRITEMOCONTRATO = RA.NRITEMOCONTRATO
           JOIN FCT_CONTRATO          CO ON CO.NRSEQCONTRATO = IC.NRSEQCONTRATO

          WHERE RE.ID = :USER_ID
            AND RA.IDSITUARECGEND = '1'
            $dtapropriacaoFilter
            $serviceFilter

          UNION

         SELECT AG.NRAPROPAGENDAMENTO AS ID, 'D'||AG.NRAPROPAGENDAMENTO AS ID_TREE,
                TO_CHAR(AG.DTAPROPRIACAO, 'DD/MM/YYYY') AS NAME,
                'S'||IC.NRITEMOCONTRATO AS PROJECT_TREE,
                round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 2) || '%' AS PERCENT_COMPLETED,
                round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 2) || '%' AS PERCENT_COMPLETED_ORIGIN,
                'N' AS PROJECT, 'N' AS CONTRACT, 'Y' AS CDA, RA.NRRECURSOSAGENDCONT,
                CO.NRSEQCONTRATO, 'Y' AS APPROPRIATION,
                IC.NRITEMOCONTRATO AS DAD_ID, IC.NMITEMCONTRATO AS DAD_NAME,
                CO.NRCONTRATOFCT || ' - ' || CO.DSREFERENCIACONT AS GRANDFATHER_NAME,
                TO_CHAR((SELECT HORADEC_HORACHAR(IC.QTMEDIDACONTR) FROM DUAL)) AS QTMEDIDACONTR,
                (SELECT HORADEC_HORACHAR(AG.QTHORASAPROPRIADAS) FROM DUAL) AS QTHORASAPROPRIADAS,
                (SELECT HORADEC_HORACHAR(AA.TOTAL_APPROPRIATION) FROM DUAL) AS TOTAL_APPROPRIATION,
                (SELECT HORADEC_HORACHAR(AG.QTHORASAPROPRIADAS) FROM DUAL) AS QTHORASAPROPRIADAS_VIEW
           FROM RESOURCE_T            RE
           JOIN OPERADOR              OP ON OP.CDOPERADOR = RE.EXTERNAL_CODE
           JOIN PARCNEGOCIO           PN ON PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
           JOIN FCT_RECURSOSAGENDCONT RA ON RA.NRPARCNEPESSOA = OP.NRPARCNEGOCIO
           JOIN FCT_APROPAGENDAMENTO  AG ON AG.NRRECURSOSAGENDCONT = RA.NRRECURSOSAGENDCONT

           JOIN FCT_ITEMCONTRATO      IC ON IC.NRITEMOCONTRATO = RA.NRITEMOCONTRATO
           JOIN FCT_CONTRATO          CO ON CO.NRSEQCONTRATO = IC.NRSEQCONTRATO
           JOIN (SELECT SUM(AA.QTHORASAPROPRIADAS) AS TOTAL_APPROPRIATION, AA.NRRECURSOSAGENDCONT
                   FROM FCT_APROPAGENDAMENTO AA
                  GROUP BY AA.NRRECURSOSAGENDCONT) AA ON (AA.NRRECURSOSAGENDCONT = AG.NRRECURSOSAGENDCONT)
          WHERE RE.ID = :USER_ID
            AND RA.IDSITUARECGEND = '1'
            AND DECODE(IC.QTMEDIDACONTR, 0, 100,(TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR) < 100
            $dtapropriacaoFilter
            $serviceFilter
            )
            WHERE 1 = 1
            $filters
SQL;

        $params = array(
            'USER_ID' => $user
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function getSumOfDurationOfServiceById($filters) {
        $query = <<<SQL
           SELECT (IC.QTMEDIDACONTR * 3600) AS TOTAL_DURATION
             FROM FCT_ITEMCONTRATO IC
            WHERE 1 = 1
            $filters
SQL;

        $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        return $result[0]['TOTAL_DURATION'] ? $result[0]['TOTAL_DURATION'] : 0;
    }

	public function findServicesMnemonicsValuesRTR($nrseqcontrato, $date, $userId)
	{
		$query = <<<SQL
			SELECT IC.NMITEMCONTRATO AS TASK_NAME, NULL AS TASK_DESCRIPTION,
				   (SELECT HORADEC_HORACHAR(AG.QTHORASAPROPRIADAS) FROM DUAL) AS TASK_TIME,
				   round(((TOTAL_APPROPRIATION * 100) / IC.QTMEDIDACONTR), 0) AS TASK_CONCLUSION,
                   AG.DTAPROPRIACAO AS DATE_CDA

			   FROM RESOURCE_T            RE
			   JOIN OPERADOR              OP ON OP.CDOPERADOR = RE.EXTERNAL_CODE
			   JOIN PARCNEGOCIO           PN ON PN.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
			   JOIN FCT_RECURSOSAGENDCONT RA ON RA.NRPARCNEPESSOA = OP.NRPARCNEGOCIO
			   JOIN FCT_APROPAGENDAMENTO  AG ON AG.NRRECURSOSAGENDCONT = RA.NRRECURSOSAGENDCONT AND TO_CHAR(AG.DTAPROPRIACAO, 'DD/MM/YYYY') = :DATECDA

			   JOIN FCT_ITEMCONTRATO      IC ON IC.NRITEMOCONTRATO = RA.NRITEMOCONTRATO
			   JOIN FCT_CONTRATO          CO ON CO.NRSEQCONTRATO = IC.NRSEQCONTRATO
			   JOIN CLIENTE               CL ON CL.NRPARCNEGOCIO = CO.NRPARCNEGOCIO
			   JOIN (SELECT SUM(AA.QTHORASAPROPRIADAS) AS TOTAL_APPROPRIATION, AA.NRRECURSOSAGENDCONT
					   FROM FCT_APROPAGENDAMENTO AA
					  GROUP BY AA.NRRECURSOSAGENDCONT) AA ON (AA.NRRECURSOSAGENDCONT = AG.NRRECURSOSAGENDCONT)
			  WHERE RE.ID = :USER_ID
				AND CO.NRSEQCONTRATO = :NRSEQCONTRATO
SQL;

		$params = array(
			':USER_ID' => $userId,
			':DATECDA' => $date,
			':NRSEQCONTRATO' => $nrseqcontrato
		);

		return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
	}


}

